//------------------------------------------
// Invision Power Board v2.3
// (c) 2008 SAT | Game-Play.ru Team
// Module: Awards System
// http://www.game-play.ru
//------------------------------------------

var comment_cache    = new Array();
var ajax_loaded      = 1;

/*--------------------------------------------*/
// Ajax: Show Edit Form
/*--------------------------------------------*/

function com_prep_for_edit( com_id, event )
{
	//----------------------------------
	// Cancel bubble (Prevent IE scroll...)
	//----------------------------------

	global_cancel_bubble( event, true );
	
	var com_main_obj = document.getElementById( 'comment-main-' + com_id );
	var com_box_top  = _get_obj_toppos( com_main_obj );
	
	//----------------------------------
	// INIT
	//----------------------------------
	
	var url = ipb_var_base_url+'automodule=awards&inc=memawards&CODE=01&com='+com_id;
	
	if ( ! comment_cache[ com_id ] || comment_cache[ com_id ] == '' )
	{
		comment_cache[ com_id ] = document.getElementById( 'comment-'+com_id ).innerHTML;
	}

	//----------------------------------
	// Attempt to close open menus
	//----------------------------------
	
	try
	{
		menu_action_close();
	}
	catch(e)
	{
		//alert( e );
	}
	
	/*--------------------------------------------*/
	// Main function to do on request
	// Must be defined first!!
	/*--------------------------------------------*/
	
	do_request_function = function()
	{
		//----------------------------------
		// Ignore unless we're ready to go
		//----------------------------------
		
		if ( ! xmlobj.readystate_ready_and_ok() )
		{
			xmlobj.show_loading();
			return;
		}
		
		xmlobj.hide_loading();
		
		//----------------------------------
		// INIT
		//----------------------------------
		
		var html = xmlobj.xmlhandler.responseText;
		

		if ( html.match( /^ERROR:/ )  )
		{
			html = html.replace( /^ERROR:/, '' );			
			alert( html );
		}
		else 
		{
			if ( com_box_top )
			{
				scroll( 0, com_box_top - 30 );
			}
			
			document.getElementById( 'comment-'+com_id ).innerHTML = html;

			//-----------------------------------------
			// Set up new editor
			//-----------------------------------------
			
			IPS_Lite_Editor[ com_id ] = new ips_text_editor_lite( com_id );
			IPS_Lite_Editor[ com_id ].init();
		}
		
	}
	
	//----------------------------------
	// LOAD XML
	//----------------------------------
	
	xmlobj = new ajax_request();
	xmlobj.onreadystatechange( do_request_function );
	
	xmlobj.process( url );
	
	return false;
}


/*--------------------------------------------*/
// Ajax: Use full editor
/*--------------------------------------------*/

function com_fulleditor_for_edit( com_id, aid )
{
	if ( com_id && aid )
	{
		var _form = document.getElementById( 'quick-edit-form-' + com_id );
		var _url  = ipb_var_base_url + 'automodule=awards&inc=comments&aid='+ aid +'&CODE=doeditcomment&comment_id=' + com_id + '&st=' + ipb_var_st + '&_from=quickedit';
		
		_form.action = _url;
		_form.method = 'POST';
		
		_form.submit();
		
		xmlobj.show_loading();
		
		return false;
	}
	else
	{
		return false;
	}
}

/*--------------------------------------------*/
// Ajax: Cancel for edit
/*--------------------------------------------*/

function ajax_cancel_com_edit( com_id )
{
	if ( comment_cache[ com_id ] != "" )
	{
		document.getElementById( 'comment-'+com_id ).innerHTML = comment_cache[ com_id ];
	}
	
	return false;
}

/*--------------------------------------------*/
// Ajax: Save for edit
/*--------------------------------------------*/

function com_save_edit( com_id )
{
	//----------------------------------
	// INIT
	//----------------------------------
	var url    = ipb_var_base_url+'automodule=awards&inc=memawards&CODE=02&com='+com_id + '&md5check='+ipb_md5_check;
	var fields = new Array();

	//----------------------------------
	// Populate fields
	//----------------------------------
	
	fields['md5check']    = ipb_md5_check;
	fields['com']         = com_id;
	fields['automodule']  = 'awards';
	fields['inc']         = 'memawards';
	fields['CODE']        = '02';
	fields['Post']        = document.getElementById( com_id + '_textarea' ).value;
	fields['std_used']    = 1;  // Make sure STD BBCode parser is used

	try
	{
		fields['append_edit'] = document.getElementById( 'append_edit-'+com_id ).checked ? 1 : 0;
	}
	catch(e)
	{
		//fields['append_edit'] = 1;
	}

	//----------------------------------
	// Is there a post?
	//----------------------------------
	
	var post_check = fields['Post'];
	
	if ( post_check.replace( /^\s*|\s*$/g, "" ) == "" )
	{
		alert( js_no_empty_post );
		return false;
	}
	
	/*--------------------------------------------*/
	// Main function to do on request
	// Must be defined first!!
	/*--------------------------------------------*/
	
	do_request_function = function()
	{
		//----------------------------------
		// Ignore unless we're ready to go
		//----------------------------------
		
		if ( ! xmlobj.readystate_ready_and_ok() )
		{
			xmlobj.show_loading();
			return;
		}
		
		xmlobj.hide_loading();
		
		//----------------------------------
		// INIT
		//----------------------------------
		
		var html = xmlobj.xmlhandler.responseText;

		if ( html.match( /^ERROR:/ ) )
		{
			html = html.replace( /^ERROR:/, '' );			
			alert( html );
		}
		else
		{		
			document.getElementById( 'comment-'+com_id ).innerHTML = html;
			comment_cache[ com_id ] = '';
		}		
	}
	
	//----------------------------------
	// LOAD XML
	//----------------------------------
	
	xmlobj = new ajax_request();
	xmlobj.onreadystatechange( do_request_function );
	var xmlreturn = xmlobj.process( url, 'POST', xmlobj.format_for_post(fields) );
	
	return false;
}

/*--------------------------------------------*/
// Multi quote
/*--------------------------------------------*/

function multiquote_add_comment(id)
{
	saved = new Array();
	clean = new Array();
	add   = 1;
	
	//-----------------------------------
	// Get any saved info
	//-----------------------------------
	
	if ( tmp = my_getcookie('award_pids') )
	{
		saved = tmp.split(",");
	}
	
	//-----------------------------------
	// Remove bit if exists
	//-----------------------------------
	
	for( i = 0 ; i < saved.length; i++ )
	{
		if ( saved[i] != "" )
		{
			if ( saved[i] == id )
			{
				 add = 0;
			}
			else
			{
				clean[clean.length] = saved[i];
			}
		}
	}
	
	//-----------------------------------
	// Add?
	//-----------------------------------
	
	if ( add )
	{
		clean[ clean.length ] = id;
		eval("document.mad_"+id+".src=removequotebutton");
		eval("document.mad_"+id+".title='-'");
	}
	else
	{
		eval(" document.mad_"+id+".src=addquotebutton");
		eval("document.mad_"+id+".title='+'");
	}
	
	my_setcookie( 'award_pids', clean.join(','), 0 );
	
	return false;
}

/*--------------------------------------------*/
// Toggle selection
//*--------------------------------------------*/

function awards_toggle_pid( pid )
{
	//-----------------------------------
	// Got a number?
	//-----------------------------------
	
	if ( isNaN( pid ) )
	{
		return false;
	}
	
	saved = new Array();
	clean = new Array();
	add   = 1;
	
	//-----------------------------------
	// Get form info
	//-----------------------------------
	
	tmp = document.modform.awardsmodpids.value;
	
	saved = tmp.split(",");
	
	//-----------------------------------
	// Remove bit if exists
	//-----------------------------------
	
	for( i = 0 ; i < saved.length; i++ )
	{
		if ( saved[i] != "" )
		{
			if ( saved[i] == pid )
			{
				 add = 0;
			}
			else
			{
				clean[clean.length] = saved[i];
			}
		}
	}
	
	//-----------------------------------
	// Add?
	//-----------------------------------
	
	if ( add )
	{
		clean[ clean.length ] = pid;
		eval("document.pid"+pid+".src=selectedbutton");
	}
	else
	{
		eval(" document.pid"+pid+".src=unselectedbutton");
	}
	
	newvalue = clean.join(',');
	
	my_setcookie( 'awardsmodpids', newvalue, 0 );
	
	document.modform.awardsmodpids.value = newvalue;
	
	newcount = stacksize(clean);
	
	document.modform.gobutton.value = newcount ? lang_gobutton + ' (' + newcount + ')' : lang_gobutton;
	
	return false;
};

/*--------------------------------------------*/
// Check delete
/*--------------------------------------------*/

function checkform()
{
	if ( ! document.modform.awardsmodpids.value )
	{
		return false;
	}
	
	isDelete = document.getElementById( 'selectact' ).value;
	
	if (isDelete == 'delcomments')
	{
		formCheck = confirm( lang_suredelete );
		
		if (formCheck == true)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
}

/*--------------------------------------------*/
// Link to comment
/*--------------------------------------------*/

function link_to_comment(pid)
{
	temp = prompt( ipb_lang_tt_prompt, ipb_var_base_url + "automodule=awards&inc=findcomment&com=" + pid );
	return false;
}

/*--------------------------------------------*/
// Delete comment
/*--------------------------------------------*/

function delete_comment(theURL)
{
	if (confirm( ipb_lang_js_del_1 ))
	{
		window.location.href=theURL;
	}
	else
	{
		alert ( ipb_lang_js_del_2 );
	} 
}