<?php

/*
+--------------------------------------------------------------------------
|   Awards System Module v3.1.0
|   =============================================
|   by SAT
|   (c) 2005 - 2008 Game-Play.ru TEAM
|   http://www.game-play.ru
|   =============================================
|   Web: http://www.game-play.ru
+--------------------------------------------------------------------------
|
|   > Awards System (Award Comments module)
|   > Script written by SAT
|
+--------------------------------------------------------------------------
*/

if ( ! defined( 'IN_IPB' ) )
{
        print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded all the relevant files.";
        exit();
}

class awards_comments
{
        var $ipsclass;
        var $awards_lib;
        var $lib;

        var $output="";
        var $nav = "";
        var $page_title = "";
        var $md5_check  = "";

        var $mem_info = array();
        var $class_post = '';
        var $parser     = '';
        var $han_editor = '';

        var $awards_id  = 0;
        var $award      = array();

        /*-------------------------------------------------------------------------*/
        // Autorun....
        /*-------------------------------------------------------------------------*/

        function auto_run_module( )
        {


        		//-----------------------------------------
        		// get award information
        		//-----------------------------------------

        		$this->awards_id = intval($this->ipsclass->input['aid']);

                $this->ipsclass->DB->cache_add_query( 'get_award_comments_info' , array( 'aid' => $this->awards_id ), 'awards_sql_queries' );

                $this->ipsclass->DB->cache_exec_query();

                $this->award = $this->ipsclass->DB->fetch_row();

                if( !$this->award['aid'] )
                {
                		$this->awards_lib->award_error('award_not_exists');
                }

                //-----------------------------------------
                // Check Permissions
                //-----------------------------------------

          		if( $this->award['mid'] == $this->ipsclass->member['id'] )
          		{
          				$own_award = 1;
          		}
          		else
          		{
          				$own_award = 0;
          		}

          		$this->awards_lib->get_comments_permission( $this->award, $own_award );

          		if( !$this->awards_lib->comments_enable )
          		{
          				$this->awards_lib->award_error('comments_no_add');
          		}

                //-----------------------------------------
                // Prep form check
                //-----------------------------------------

                $this->md5_check = $this->ipsclass->return_md5_check();

				//-------------------------------------------------------
				// Get the html and language files
				//-------------------------------------------------------

				if( !is_object( $this->ipsclass->compiled_templates['skin_awards_comments'] ) )
				{
						$this->ipsclass->load_template('skin_awards_comments');
				}

                //-----------------------------------
                // Load posting languege
                //-----------------------------------

                $this->ipsclass->load_language( 'lang_post' );
				$this->ipsclass->load_language( 'lang_topic' );

                //-----------------------------------
                // Load the parser
                //-----------------------------------

                require_once( ROOT_PATH."sources/handlers/han_parse_bbcode.php" );
                $this->parser                      =  new parse_bbcode();
                $this->parser->ipsclass            =& $this->ipsclass;
                $this->parser->allow_update_caches = 1;

                //-----------------------------------
                // Parser settings
                //-----------------------------------

                $this->parser->parse_html      = 0;
                $this->parser->parse_nl2br     = 1;
                $this->parser->parse_smilies   = 1;
                $this->parser->parse_bbcode    = 1;
                $this->parser->bypass_badwords = intval($this->ipsclass->member['g_bypass_badwords']);

                //-----------------------------------
                // Load up the rte/std editor handler
                //-----------------------------------

                require_once( ROOT_PATH."sources/handlers/han_editor.php" );
                $this->han_editor           = new han_editor();
                $this->han_editor->ipsclass =& $this->ipsclass;
                $this->han_editor->init();

                //--------------------------------------------
                // Prep form check
                //--------------------------------------------

                switch($this->ipsclass->input['CODE'])
                {

                        case 'delet':
                                $this->award_member_delet();
                                break;

                        case 'doaddcomment':
                        		if( $this->ipsclass->input['submit'] )
                        		{
                                	$this->process_do('add');
                                }
                                else
                                {
                                	$this->form_do('add');
                                }
                                break;
                        case 'doeditcomment':
                        		if( $this->ipsclass->input['submit'] )
                        		{
                                	$this->process_do('edit');
                                }
                                else
                                {
                                	$this->form_do('edit');
                                }
                                break;
                        case 'approvecomments':
                        		$this->multi_approve_comments( 1 );
                        		break;
                        case 'unapprovecomments':
                        		$this->multi_approve_comments( 0 );
                        		break;
                        case 'delcomments':
                        		$this->multi_del_comments( );
                        		break;
                        case 'delcomment':
                        		$this->del_comment( );
                        		break;
                        default:
                                $this->show_award( );
                                break;
                }

                $this->ipsclass->print->add_output("$this->output");

                $this->page_title = $this->ipsclass->vars['board_name'] . " -> " . $this->page_title;

                $this->ipsclass->print->do_output( array( 'TITLE' => $this->page_title,
                										  'JS'    => $this->ipsclass->compiled_templates['skin_global']->get_rte_css(),
                										  'NAV'   => $this->nav ) );

        }


		/*-------------------------------------------------------------------------*/
		// Delete comment
		/*-------------------------------------------------------------------------*/

        function del_comment()
        {
        	$cid = intval($this->ipsclass->input['comment']);

			$passed = 0;

			if ($this->ipsclass->member['g_is_supmod'] == 1)
			{
				$passed = 1;
			}

			else if ($this->awards_lib->comments_mod == 1)
			{
				$passed = 1;
			}
			else
			{
				$passed = 0;
			}

			if ($passed != 1)
			{
				$this->awards_lib->award_error('moderate_no_permission');
			}


			$this->delete_comments( $cid );

			$this->rebuild_award_comments( $this->award['aid']);


			$this->ipsclass->print->redirect_screen( $this->ipsclass->lang['aw_del_success'], "automodule=awards&amp;inc=comments&amp;aid={$this->award['aid']}" );

        }

		/*-------------------------------------------------------------------------*/
		// Delete comments
		/*-------------------------------------------------------------------------*/

		function multi_del_comments()
		{
			$this->pids  = $this->get_pids();

			$passed = 0;

			if ($this->ipsclass->member['g_is_supmod'] == 1)
			{
				$passed = 1;
			}

			else if ($this->awards_lib->comments_mod == 1)
			{
				$passed = 1;
			}
			else
			{
				$passed = 0;
			}

			if ($passed != 1)
			{
				$this->awards_lib->award_error('moderate_no_permission');
			}

			$this->delete_comments( $this->pids );

			$this->rebuild_award_comments( $this->award['aid']);


			$this->ipsclass->print->redirect_screen( $this->ipsclass->lang['aw_del_success'], "automodule=awards&amp;inc=comments&amp;aid={$this->award['aid']}&st={$this->ipsclass->input['st']}" );
		}

		/*-------------------------------------------------------------------------*/
		// Process delete comments
		/*-------------------------------------------------------------------------*/

		function delete_comments( $pids = "")
		{
			if( !$pids ) return;

			$q = "";

			if( is_array( $pids ) )
			{
				if( !count( $pids ) ) return;

				$q   = " IN (".implode(',', $pids).")";
				$log = implode(',', $pids);
			}
			else
			{
				$q   = "={$pids}";
				$log = $pids;
			}

			$this->ipsclass->DB->simple_construct( array( 'delete' => 'awards_comments', 'where' => "pid{$q} AND award_id={$this->award['aid']}" ) );
			$this->ipsclass->DB->simple_exec();


			$this->ipsclass->DB->do_insert( 'moderator_logs', array (
                                                                     'forum_id'    => 0,
                                                                     'topic_id'    => 0,
                                                                     'post_id'     => 0,
                                                                     'member_id'   => $this->ipsclass->member['id'],
                                                                     'member_name' => $this->ipsclass->member['members_display_name'],
                                                                     'ip_address'  => $this->ipsclass->input['IP_ADDRESS'],
                                                                     'http_referer'=> @$_SERVER['HTTP_REFERER'],
                                                                     'ctime'       => time(),
                                                                     'topic_title' => '',
                                                                     'action'      => "Delete comments({$log}) in award ".$this->award['aid'],
                                                                     'query_string'=> @$_SERVER['QUERY_STRING'],
                                                                    )  );
		}


		/*-------------------------------------------------------------------------*/
		// Approve/unapprove comments
		/*-------------------------------------------------------------------------*/

		function multi_approve_comments($approve=1)
		{

			$this->pids  = $this->get_pids();

			$passed = 0;

			if ($this->ipsclass->member['g_is_supmod'] == 1)
			{
				$passed = 1;
			}

			else if ($this->awards_lib->comments_mod == 1)
			{
				$passed = 1;
			}
			else
			{
				$passed = 0;
			}

			if ($passed != 1)
			{
				$this->awards_lib->award_error('moderate_no_permission');
			}


			if ( count($this->pids) )
			{
				$this->ipsclass->DB->do_update( 'awards_comments', array( 'approved' => $approve ), 'award_id=' . $this->award['aid'] . ' AND pid IN ('. implode(",", $this->pids) .')' );
			}

			if( $approve )
			{
				$this->ipsclass->DB->do_insert( 'moderator_logs', array (
                                                                     'forum_id'    => 0,
                                                                     'topic_id'    => 0,
                                                                     'post_id'     => 0,
                                                                     'member_id'   => $this->ipsclass->member['id'],
                                                                     'member_name' => $this->ipsclass->member['members_display_name'],
                                                                     'ip_address'  => $this->ipsclass->input['IP_ADDRESS'],
                                                                     'http_referer'=> @$_SERVER['HTTP_REFERER'],
                                                                     'ctime'       => time(),
                                                                     'topic_title' => '',
                                                                     'action'      => "Approve comments(".implode(',', $this->pids).") in award ".$this->award['aid'],
                                                                     'query_string'=> @$_SERVER['QUERY_STRING'],
                                                                    )  );
			}
			else
			{
				$this->ipsclass->DB->do_insert( 'moderator_logs', array (
                                                                     'forum_id'    => 0,
                                                                     'topic_id'    => 0,
                                                                     'post_id'     => 0,
                                                                     'member_id'   => $this->ipsclass->member['id'],
                                                                     'member_name' => $this->ipsclass->member['members_display_name'],
                                                                     'ip_address'  => $this->ipsclass->input['IP_ADDRESS'],
                                                                     'http_referer'=> @$_SERVER['HTTP_REFERER'],
                                                                     'ctime'       => time(),
                                                                     'topic_title' => '',
                                                                     'action'      => "UNapprove comments(".implode(',', $this->pids).") in award ".$this->award['aid'],
                                                                     'query_string'=> @$_SERVER['QUERY_STRING'],
                                                                    )  );
			}

			$this->rebuild_award_comments( $this->award['aid']);

			if( $approve )
			{
				$this->ipsclass->print->redirect_screen( $this->ipsclass->lang['aw_approve_success'], "automodule=awards&amp;inc=comments&amp;aid={$this->award['aid']}&st={$this->ipsclass->input['st']}" );
			}
			else
			{
				$this->ipsclass->print->redirect_screen( $this->ipsclass->lang['aw_unapprove_success'], "automodule=awards&amp;inc=comments&amp;aid={$this->award['aid']}&st={$this->ipsclass->input['st']}" );
			}
		}

		/*-------------------------------------------------------------------------*/
		// Get Pids
		/*-------------------------------------------------------------------------*/

		function get_pids()
		{
				$ids = array();

 				$ids = explode( ',', $this->ipsclass->input['awardsmodpids'] );

 				if ( count($ids) < 1 )
 				{
 					$this->awards_lib->award_error('cp_error_no_topics');
 					return;
 				}

 				$ids = $this->ipsclass->clean_int_array( $ids );

 				return $ids;
		}

		/*-------------------------------------------------------------------------*/
		// rebuild avards comments
		/*-------------------------------------------------------------------------*/

		function rebuild_award_comments( $aid = 0 )
		{
			if( !$aid ) return;

			$count = $this->ipsclass->DB->build_and_exec_query( array( 'select' => 'COUNT(c.pid) as total', 'from' => 'awards_comments c', 'where' => "c.award_id={$aid} AND c.approved=1" ) );

			$comments_count = $count['total'];

			$this->ipsclass->DB->do_update('awards', array('comments' => $comments_count), "aid={$aid}");
		}

        /*-------------------------------------------------------------------------*/
        // Form edit or add
        /*-------------------------------------------------------------------------*/

        function form_do( $type = 'add' )
        {
			//-----------------------------------------------------------
			// Can comment?
			//-----------------------------------------------------------

        	if( !$this->ipsclass->member['g_awards_add_comments'] )
        	{
        		$this->awards_lib->award_error('aw_error_do_comment');
        	}

			//-----------------------------------------------------------
			// Get the skin and language
			//-----------------------------------------------------------

			$this->ipsclass->load_language( 'lang_post' );

			if( !isset($this->ipsclass->input['Post']) and $type == 'edit' )
			{

				$this->comment_id = intval($this->ipsclass->input['comment_id']);

				// Get the comment info
				$info = $this->ipsclass->DB->build_and_exec_query( array( 'select' => '*',
																  		  'from'   => 'awards_comments',
																  		  'where'  => "pid={$this->comment_id}"
														 				) 		);

				if( !$info['pid'] )
				{
					$this->awards_lib->award_error('missing_files');
				}

				if ( $this->han_editor->method == 'rte' )
				{
					$info['comment'] = $this->parser->convert_ipb_html_to_html( $info['comment'] );
				}
				else
				{
					$this->parser->parse_html    = 0;
					$this->parser->parse_nl2br   = 0;
					$this->parser->parse_smilies = $info['use_emo'];
					$this->parser->parse_bbcode  = 1;
					$info['comment'] = $this->parser->pre_edit_parse( $info['comment'] );
				}

			}

			if( $type == 'edit' )
			{
				if( $this->edit_permission( $this->comment_id, $info, $info['post_date'] ) === FALSE)
				{
					$this->awards_lib->award_error('not_op');
				}
			}

			if( count($info) and is_array($info) )
			{
				$this->ipsclass->input['enablesig']   = $info['use_sig'];
				$this->ipsclass->input['enableemo']   = $info['use_emo'];
			}
			else
			{

				$this->ipsclass->input['enablesig']   = ($this->ipsclass->input['enablesig']   == 'yes' or !isset($this->ipsclass->input['enablesig'])) ? 1 : 0;
				$this->ipsclass->input['enableemo']   = ($this->ipsclass->input['enableemo']   == 'yes' or !isset($this->ipsclass->input['enableemo'])) ? 1 : 0;
			}

			$this->ipsclass->input['Post'] = $this->ipsclass->remove_tags( $this->ipsclass->input['Post'] );

			if( !$info['comment'] )
			{
				$raw_post = $this->check_multi_quote();
			}
			else
			{
				$raw_post = $info['comment'];
			}

			$editor_html = $this->han_editor->show_editor( $raw_post, 'Post' );

			if ( isset($this->post_errors) AND $this->post_errors )
			{
				$this->output .= $this->ipsclass->compiled_templates['skin_awards_comments']->errors( $this->ipsclass->lang[ $this->post_errors ]);
			}

			$this->output .= $this->ipsclass->compiled_templates[ 'skin_awards_comments' ]->reply_form_top( 'aw_'.$type.'_commenting', $type, $this->md5_check );
			$this->output .= $this->ipsclass->compiled_templates[ 'skin_awards_comments' ]->post_description_field( $editor_html );
			$this->output .= $this->ipsclass->compiled_templates[ 'skin_awards_comments' ]->get_post_options( $this->ipsclass->input['enablesig'] ? 'checked' : '',
																											  $this->ipsclass->input['enableemo'] ? 'checked' : '');
			$this->output .= $this->ipsclass->compiled_templates[ 'skin_awards_comments' ]->post_form_end( 'aw_'.$type.'_comment' );

			// Append Edit Box?
			if( $this->ipsclass->member['g_append_edit'] and $type == 'edit')
			{
				if($info['append_edit'])
				{
					$edit_chk = 'checked';
				}
				else
				{
					$edit_chk = '';
				}
				$this->output = str_replace( "<!-- APPEND_EDIT -->", '<br />'.$this->ipsclass->compiled_templates[ 'skin_awards_comments' ]->get_append_chk( $edit_chk ), $this->output );
			}

			if( !$this->ipsclass->member['id'] AND $this->ipsclass->vars['guest_captcha'] )
			{
				$this->output = str_replace( "<!--GUEST.CAPTCHA-->", $this->ipsclass->compiled_templates['skin_awards_comments']->guest_captcha(), $this->output );

				$imgid = md5( uniqid(microtime()) );

				if( $this->ipsclass->vars['bot_antispam'] == 'gd' )
				{
					//-----------------------------------------
					// Get 6 random chars
					//-----------------------------------------

					$img_code = strtoupper( substr( md5($imgid), 0, 6 ) );
				}
				else
				{
					//-----------------------------------------
					// Set a new 6 character numerical string
					//-----------------------------------------

					mt_srand ((double) microtime() * 1000000);

					$img_code = mt_rand(100000,999999);
				}

				$this->ipsclass->DB->do_insert( 'reg_antispam', array (	'regid'      => $imgid,
												   						'regcode'    => $img_code,
												   						'ip_address' => $this->ipsclass->input['IP_ADDRESS'],
												   						'ctime'      => time(),
									   									) );

				if( $this->ipsclass->vars['guest_captcha'] == 'gd' )
				{
					$this->output = str_replace( "<!--CAPTCHA.IMAGE-->", $this->ipsclass->compiled_templates['skin_awards_comments']->bot_antispam_gd( $imgid ), $this->output );
				}
				else if ( $this->ipsclass->vars['guest_captcha'] == 'gif' )
				{
					$this->output = str_replace( "<!--CAPTCHA.IMAGE-->", $this->ipsclass->compiled_templates['skin_awards_comments']->bot_antispam_gif( $imgid ),$this->output );
				}
			}

			$this->page_title = $this->ipsclass->lang['page_title_aw'] . " -> " . $this->ipsclass->lang['aw_'.$type.'_commenting'];

			$this->nav[] = "<a href='{$this->ipsclass->base_url}automodule=awards'>{$this->ipsclass->lang['page_title_aw']}</a>";

			$this->nav[] = $this->ipsclass->lang['aw_commenting_'.$type]."<a href='{$this->ipsclass->base_url}automodule=awards&amp;inc=comments&amp;aid={$this->award['aid']}'>{$this->award['title']}</a>";

        }


        /*-------------------------------------------------------------------------*/
        // Process add or edit comment
        /*-------------------------------------------------------------------------*/

        function process_do( $type = 'add' )
        {
			//-----------------------------------------------------------
			// Can comment?
			//-----------------------------------------------------------

        	if( !$this->ipsclass->member['g_awards_add_comments'] )
        	{
        		$this->awards_lib->award_error('aw_error_do_comment');
        	}

         	//-----------------------------------------
          	// Nawty, Nawty!
          	//-----------------------------------------

          	if ($this->ipsclass->input['auth_key'] != $this->md5_check )
          	{
          		$this->awards_lib->award_error('del_post');
          	}

			if( $this->ipsclass->input['preview'] )
			{
				$this->form_do( $type );
				return;
			}

			if( $type == 'edit' )
			{
				$this->comment_id = intval($this->ipsclass->input['comment_id']);

				// Get the comment info
				$info = $this->ipsclass->DB->build_and_exec_query( array( 'select' => '*',
																  		  'from'   => 'awards_comments',
																  		  'where'  => "pid={$this->comment_id}"
														 				) 		);

				if( !$info['pid'] )
				{
					$this->awards_lib->award_error('missing_files');
				}

				if( $this->edit_permission( $this->comment_id, $info, $info['post_date'] ) === FALSE)
				{
					$this->awards_lib->award_error('not_op');
				}
			}

   			//---------------------------------------
			// Make sure they actually made a comment
			//---------------------------------------

			if( !$this->ipsclass->input['Post'] )
			{
				$this->awards_lib->award_error( 'aw_no_comment' );
			}

			//---------------------------------------
			// and that it's not too big...
			//---------------------------------------

			$this->ipsclass->vars['max_post_length'] = $this->ipsclass->vars['max_post_length'] ? $this->ipsclass->vars['max_post_length'] : 2140000;

			if ( strlen( trim( $this->ipsclass->my_br2nl( $_POST['Post'] ) ) ) < 1 )
			{
				if ( ! $_POST['preview'] )
				{
					$this->awards_lib->award_error( 'no_post' );
				}
			}

			if( strlen( $this->ipsclass->input['Post'] ) > ($this->ipsclass->vars['max_post_length'] * 1024 ) )
			{
				$this->awards_lib->award_error( 'post_too_long' );
			}

			//-----------------------------------------
			// Guest w/ CAPTCHA?
			//-----------------------------------------

			if( $this->ipsclass->member['id'] == 0 AND $this->ipsclass->vars['guest_captcha'] )
			{
				//-----------------------------------------
				// Security code stuff
				//-----------------------------------------

				if( isset($this->ipsclass->input['fast_reply_used']) AND $this->ipsclass->input['fast_reply_used'] == 1 )
				{
					$this->post_errors = 'reg_code_enter';
					$this->form_do( $type );
					return;
				}

				if ($this->ipsclass->input['imgid'] == "")
				{
					$this->post_errors = 'err_reg_code';
					$this->form_do( $type );
					return;
				}

				$this->ipsclass->DB->simple_construct( array( 'select' => '*',
														  	  'from'   => 'reg_antispam',
														  	  'where'  => "regid='".trim($this->ipsclass->txt_alphanumerical_clean($this->ipsclass->input['imgid']))."'"
												 			)      );

				$this->ipsclass->DB->simple_exec();

				if ( ! $row = $this->ipsclass->DB->fetch_row() )
				{
					$this->post_errors = 'err_reg_code';
					$this->form_do( $type );
					return;
				}

				if ( trim( $this->ipsclass->txt_alphanumerical_clean($this->ipsclass->input['captcha']) ) != $row['regcode'] )
				{
					$this->post_errors = 'err_reg_code';
					$this->form_do( $type );
					return;
				}

				$this->ipsclass->DB->do_delete( 'reg_antispam', "regid='".trim($this->ipsclass->txt_alphanumerical_clean($this->ipsclass->input['imgid']))."'" );
			}

			//---------------------------------------
			// Prepare the comment for db insertion
			//---------------------------------------

			$comment = $this->han_editor->process_raw_post( 'Post' );
			$comment = $this->parser->pre_db_parse( $comment );



			//---------------------------------------
			// Update or Add
			//---------------------------------------

			if( $type == 'add' )
			{
				// send trakker
				$this->awards_tracker( $this->award['aid'], $this->award['title'], $this->award );

				$save = array( 'author_id'   => $this->ipsclass->member['id'],
						   	   'author_name' => $this->ipsclass->member['members_display_name'],
						       'use_sig'     => $this->ipsclass->input['enablesig'] ? 1 : 0,
						       'use_emo'     => $this->ipsclass->input['enableemo'] ? 1 : 0,
						       'ip_address'  => $this->ipsclass->input['IP_ADDRESS'],
						       'post_date'   => time(),
						       'comment'     => $comment,
						       'award_id'    => $this->award['aid'],
						       'award_info_id' => $this->award['awards_id'],
						       'approved'    => 1,
						);

				$this->ipsclass->DB->simple_update( 'awards', 'comments=comments+1', "aid={$this->award['aid']}", 1 );
				$this->ipsclass->DB->simple_exec();

				$this->ipsclass->DB->do_insert( 'awards_comments', $save );
			}
			else
			{
				$append_edit = 1;

				if( $this->ipsclass->member['g_append_edit'] )
				{
					if( $this->ipsclass->input['add_edit'] != 1 )
					{
						$append_edit = 0;
					}
				}


				$save = array( 'use_sig'     => $this->ipsclass->input['enablesig'] ? 1 : 0,
						       'use_emo'     => $this->ipsclass->input['enableemo'] ? 1 : 0,
						       'comment'     => $comment,
						       'append_edit' => $append_edit,
						       'edit_time'	 => time(),
						       'edit_name'	 => $this->ipsclass->member['members_display_name'],
						);

                $this->ipsclass->DB->do_update( 'awards_comments', $save, 'pid='.$this->comment_id );
			}


			$this->ipsclass->print->redirect_screen( $this->ipsclass->lang['aw_'.$type.'_success'], "automodule=awards&amp;inc=comments&amp;aid={$this->award['aid']}" );

        }

        /*-------------------------------------------------------------------------*/
        // Show award information with comments
        /*-------------------------------------------------------------------------*/

        function show_award()
        {
        		$this->nav[] = "<a href='".$this->ipsclass->base_url."automodule=awards'>".$this->ipsclass->lang['page_title_aw']."</a>";
                $this->nav[] = "<a href='".$this->ipsclass->base_url."automodule=awards&inc=comments&aid=".$this->awards_id."'>".$this->ipsclass->lang['aw_show_comments']."</a>";

				$this->page_title = $this->ipsclass->lang['aw_show_comments'];

                $this->show_award_info();

				//-------------------------------------------------------
				// Quck Reply
				//-------------------------------------------------------

				if( $this->ipsclass->member['g_awards_add_comments'] )
				{
					$this->data['comment_button'] = $this->ipsclass->compiled_templates[ 'skin_awards_comments' ]->add_comment_button( $this->awards_id );
				}
				else
				{
					$this->data['comment_button'] = "";
				}

				//-------------------------------------------------------
				// Comment time!
				//-------------------------------------------------------

				require( ROOT_PATH."modules/awards/lib/comment_view.php" );
				$comments 				= new comment_view();
				$comments->ipsclass 	= &$this->ipsclass;
				$comments->awards_lib   = &$this->awards_lib;
				$comments->comments_mod = $this->awards_lib->comments_mod;
				$comments->parser       = &$this->parser;
				$comments->award        = &$this->award;
				$comments->init_lib(  $this->data  );

				$this->output .= $comments->get_comments();

				$this->output .= $this->ipsclass->compiled_templates[ 'skin_awards_comments' ]->page_end( $this->data );

				if($this->ipsclass->member['g_is_supmod'] or $this->awards_lib->comments_mod )
				{
						if( $this->awards_lib->comments_count )
						{
							$this->output = str_replace("<!--AWARDS_MOD_COMMENTS-->", $this->ipsclass->compiled_templates[ 'skin_awards_comments' ]->mod_form( ), $this->output);
						}
				}

				if( $this->ipsclass->member['g_awards_add_comments'] )
				{
					$show = "none";

					$sqr = isset($this->ipsclass->member['_cache']['qr_open']) ? $this->ipsclass->member['_cache']['qr_open'] : 0;

					if ( $sqr == 1 )
					{
						$show = "show";
					}

					$this->output = str_replace( "<!--IBF.QUICK_REPLY_CLOSED-->", $this->ipsclass->compiled_templates[ 'skin_awards_comments' ]->quick_reply_box_closed(), $this->output );
					$this->output = str_replace( "<!--IBF.QUICK_REPLY_OPEN-->" , $this->ipsclass->compiled_templates[ 'skin_awards_comments' ]->quick_reply_box_open($show, $this->md5_check), $this->output );
				}

        }

        /*-------------------------------------------------------------------------*/
        // Show Awards information
        /*-------------------------------------------------------------------------*/

		function show_award_info( )
		{

			//-------------------------------------------------------
			// Category or album?
			//-------------------------------------------------------

			$this->award['reason'] = $this->parser->pre_display_parse( $this->award['reason'] );

            if( !$this->award['mname'] )
            {
            	$this->award['mname'] = $this->ipsclass->make_profile_link( $this->award['members_display_name'],  $this->award['mid']);
            }

            $this->award['prefix'] = $this->ipsclass->cache['group_cache'][ $this->award['mgr'] ]['prefix'];
            $this->award['suffix'] = $this->ipsclass->cache['group_cache'][ $this->award['mgr'] ]['suffix'];


            if( ! $this->ipsclass->can_use_fancy_js )
            {
            	$this->award['mem_disp_name'] = $this->ipsclass->compiled_templates['skin_awards_comments']->js_link( $this->award['cid'], $this->award['prefix'].$this->award['mem_disp_name'].$this->award['suffix'] );
            }
            else
            {
            	$this->award['mem_disp_name'] = $this->ipsclass->compiled_templates['skin_awards_comments']->xml_link( $this->award['cid'], $this->award['prefix'].$this->award['mem_disp_name'].$this->award['suffix'] );
            }

            $this->award['add_mem_award_time'] = $this->ipsclass->get_date( $this->award['add_mem_award_time'], 'LONG' );

			$this->output .= $this->ipsclass->compiled_templates[ 'skin_awards_comments' ]->awards_info( $this->award  );

		}

        /*-------------------------------------------------------------------------*/
        // add multi quote posts
        /*-------------------------------------------------------------------------*/

		function check_multi_quote()
		{
			$add_tags = 0;

			if ( ! $this->ipsclass->input['award_pids'] )
			{
				$this->ipsclass->input['award_pids'] = $this->ipsclass->my_getcookie('award_pids');

				if ($this->ipsclass->input['award_pids'] == ",")
				{
					$this->ipsclass->input['award_pids'] = "";
				}
			}

			$this->ipsclass->input['qpid'] = intval($this->ipsclass->input['qpid']);

			$this->ipsclass->input['award_pids'] = preg_replace( "/[^,\d]/", "", trim($this->ipsclass->input['award_pids']) );

			if( $this->ipsclass->input['qpid'] )
			{
				$this->ipsclass->input['award_pids'] = $this->ipsclass->input['qpid'];
			}

			if ( $this->ipsclass->input['award_pids'] )
			{
				$this->ipsclass->my_setcookie('award_pids', ',', 0);

				$this->quoted_pids = preg_split( '/,/', $this->ipsclass->input['award_pids'], -1, PREG_SPLIT_NO_EMPTY );
				//-----------------------------------------
				// Get the posts from the DB and ensure we have
				// suitable read permissions to quote them
				//-----------------------------------------

				if ( count($this->quoted_pids) )
				{
					$this->quoted_pids = $this->ipsclass->clean_int_array( $this->quoted_pids );

					$this->ipsclass->DB->cache_add_query( 'comments_get_quoted', array( 'quoted_pids' => $this->quoted_pids ), 'awards_sql_queries' );
					$q = $this->ipsclass->DB->cache_exec_query();

					while ( $tp = $this->ipsclass->DB->fetch_row( $q ) )
					{
						if ( $this->han_editor->method == 'rte' )
						{
							$tmp_post = $this->parser->convert_ipb_html_to_html(  $tp['comment'] );
						}
						else
						{
							$tmp_post = trim( $this->parser->pre_edit_parse( $tp['comment'] ) );
						}

						if ($this->ipsclass->vars['strip_quotes'])
						{
							$tmp_post = preg_replace( "#\[QUOTE(=.+?,.+?)?\].+?\[/QUOTE\]#is", "", $tmp_post );

							$tmp_post = preg_replace( "#(?:\n|\r){3,}#s", "\n", trim($tmp_post) );
						}

						if ( $tmp_post )
						{
							$raw_post .= "[quote name='".$this->parser->make_quote_safe($tp['author_name'])."' date='".$this->parser->make_quote_safe($this->ipsclass->get_date( $tp['post_date'], 'LONG', 1 ))."']\n$tmp_post\n[/quote]\n\n\n";
						}
					}

					$raw_post = trim($raw_post)."\n";
				}
			}

			if ( isset( $this->ipsclass->input['Post'] ) )
			{
				//-----------------------------------------
				// Raw post from preview?
				//-----------------------------------------

				$raw_post .= isset($_POST['Post']) ? $this->ipsclass->txt_htmlspecialchars($_POST['Post']) : "";

				if (isset($raw_post))
				{
					$raw_post = $this->ipsclass->txt_raw2form($raw_post);
				}
			}

			return $raw_post;
		}


		/*-------------------------------------------------------------------------*/
		// Awards tracker
		/*-------------------------------------------------------------------------*/

		function awards_tracker( $award_id = "", $award_name="", $award="" )
		{

				if ($award_id == "")
				{
						return TRUE;
				}


				//-----------------------------------------
				// Work out the time stamp needed to "guess"
				// if the user is still active on the board
				// We will base this guess on a period of
				// non activity of time_now - 30 minutes.
				//-----------------------------------------

				$time_limit = time() - (30*60);
				$count      = 0;
				$gotem      = array();

				$this->ipsclass->DB->build_query( array( 'select'   => 'a.aid, a.comments_mail_last_send',
												 	 	 'from'     => array( 'awards' => 'a' ),
												     	 'add_join' => array( 0 => array( 'select' => 'm.name, m.email, m.id, m.language, m.last_activity, m.members_display_name, m.mgroup, m.mgroup_others, m.awards_comments_notice',
																				  	  	  'from'   => array( 'members' => 'm' ),
																				          'where'  => "a.mid=m.id AND m.id <> {$this->ipsclass->member['id']}",
																				          'type'   => 'left'
																				          ),
																			  1 => array( 'select' => 'ai.title',
																				  	  	  'from'   => array( 'awards_info' => 'ai' ),
																				          'where'  => "ai.id=a.awards_id",
																				          'type'   => 'left'
																				          ),
																			),
												     	 'where'    => "a.aid=".intval($this->award['aid'])." AND m.id IS NOT NULL AND m.awards_comments_notice=1 AND m.last_activity < {$time_limit}"
													)      );

				$this->ipsclass->DB->exec_query();

				while ( $r = $this->ipsclass->DB->fetch_row() )
				{
						$time_max   = $r['last_activity'] + (30*60);
						if( $time_max < $r['comments_mail_last_send'] )
						{
							continue;
						}
						$gotem[ $r['aid'] ] = $r;
				}

				//-----------------------------------------
				// Row, row and parse, parse
				//-----------------------------------------

				if ( count( $gotem ) )
				{
						require_once( ROOT_PATH."modules/awards/lib/notice.php" );
                		$notificator   = new notice_lib( &$this );
                		$notificator->ipsclass =& $this->ipsclass;

						foreach( $gotem as $r )
						{
								$r['language'] = $r['language'] ? $r['language'] : 'en';

                                $notificator->member_to = $r;
                                $notificator->send_comments_notice();

								$count++;
						}
				}

				if ( $count > 0 )
				{
						//-----------------------------------------
						// Update cache with remaning email count
						//-----------------------------------------
						$this->ipsclass->cache['systemvars']['mail_queue'] += $count;
						$this->ipsclass->update_cache( array( 'name' => 'systemvars', 'array' => 1, 'deletefirst' => 0 ) );
				}

				return TRUE;
		}


	/*-------------------------------------------------------------------------*/
	// Edit permission
	/*-------------------------------------------------------------------------*/

	function edit_permission($post_id, $poster, $post_date)
	{
		if ($this->ipsclass->member['id'] == "" or $this->ipsclass->member['id'] == 0)
		{
			return FALSE;
		}

		if ($this->ipsclass->member['g_is_supmod']) return TRUE;

		if ($this->awards_lib->comments_mod) return TRUE;

		if ($poster['author_id'] == $this->ipsclass->member['id'] and ($this->ipsclass->member['g_edit_posts']))
		{
			// Have we set a time limit?

			if ($this->ipsclass->member['g_edit_cutoff'] > 0)
			{
				if ( $post_date > ( time() - ( intval($this->ipsclass->member['g_edit_cutoff']) * 60 ) ) )
				{
					return TRUE;
				}
				else
				{
					return FALSE;
				}
			}
			else
			{
				return TRUE;
			}
		}

		return FALSE;
	}



}
?>