<?php
/*
+--------------------------------------------------------------------------
|   Awards System Module v3.1.0
|   ========================================
|   by SAT
|   (c) 2005 - 2008 Game-Play.ru TEAM
|   http://www.game-play.ru
|   ========================================
|   Email: sat@game-play.ru
+---------------------------------------------------------------------------
*/

/**
* Library/Main Awards System
*
*
* @package          Awards System
* @subpackage       Library
* @author           SAT
* @since            3.0.0
*/

class awards_lib
{

    var $ipsclass;

    var $can_accsess  = 0;
    var $non_init_lib = 0;

    var $inclist      = array();


    var $comments_enable = 1;
    var $comments_add    = 1;
    var $comments_mod    = 0;


    /*-------------------------------------------------------------------------*/
    // Get uploads dir size
    /*-------------------------------------------------------------------------*/

    function _get_uploads_size()
    {
            //-----------------------------------------
            // Make sure the uploads path is correct
            //-----------------------------------------

            $uploads_size = 0;

            if( !is_dir(ROOT_PATH.$this->ipsclass->vars['awrads_upload']) )
            {
                    return "0 Byte";
            }

            if ($dh = @opendir( ROOT_PATH.$this->ipsclass->vars['awrads_upload'] ))
            {
                    while ( $file = @readdir( $dh ) )
                    {
                            if($file != '.' and $file != '..')
                            {
                                    if ( ! preg_match( "/^index/i", $file ) )
                                    {
                                            $uploads_size += @filesize( ROOT_PATH.$this->ipsclass->vars['awrads_upload'] . "/" . $file );
                                    }
                            }
                    }

                    @closedir( $dh );
            }

            //-----------------------------------------
            // This piece of code from Jesse's (jesse@jess.on.ca) contribution
            // to the PHP manual @ php.net posted without license
            //-----------------------------------------

            if ($uploads_size >= 1048576)
            {
                    $uploads_size = round($uploads_size / 1048576 * 100 ) / 100 . " MB";
            }
            else if ($uploads_size >= 1024)
            {
                    $uploads_size = round($uploads_size / 1024 * 100 ) / 100 . " Kb";
            }
            else
            {
                    $uploads_size = $uploads_size . " Byte";
            }

            return $uploads_size;
    }


    /*-------------------------------------------------------------------------*/
    // Get uploads dir size
    /*-------------------------------------------------------------------------*/

    function upload_awards( $upload_field = 'upload_awards', $need_id = 0, $bash_img = '',  $bash_img_thumbnail = '')
    {
            if ($_FILES[ $upload_field ]['name'] != "" and ($_FILES[ $upload_field ]['name'] != "none") )
            {
                    //-----------------------------------------
                    // Get Next ID
                    //-----------------------------------------

                    if(!$need_id)
                    {
                            $aw_count = $this->ipsclass->DB->build_and_exec_query( array( 'select' => 'MAX(id) as max_id', 'from' => 'awards_info' ) );

                            $max_awards = $aw_count['max_id'] + 1;
                    }
                    else
                    {
                            $max_awards = $need_id;
                    }

                    //-----------------------------------------
                    // Load the library
                    //-----------------------------------------

                    require_once( KERNEL_PATH.'class_upload.php' );
                    $upload = new class_upload();

                    require_once( KERNEL_PATH.'class_image.php' );
                    $image = new class_image();

                    require_once( ROOT_PATH.'modules/awards/lib/image_lib.php' );

                    $image_save_transparent_lib                = new image__transparent_lib( $this );
                    $image_save_transparent_lib->ipsclass      = &$this->ipsclass;
                    $image_save_transparent_lib->ips_image_lib = &$image;
                    $image_save_transparent_lib->init_lib();

                    //-----------------------------------------
                    // Set up the variables
                    //-----------------------------------------

                    $upload->out_file_name     = 'aw-'.$max_awards;
                    $upload->out_file_dir      = ROOT_PATH . $this->ipsclass->vars['awrads_upload'];
                    $upload->max_file_size     = (10000 * 1024) * 8;  // Allow xtra for compression
                    $upload->upload_form_field = $upload_field;

                    //-----------------------------------------
                    // Populate allowed extensions
                    //-----------------------------------------

                    $this->ipsclass->DB->simple_construct( array( 'select' => '*', 'from' => 'attachments_type' ) );
                    $this->ipsclass->DB->simple_exec();

                    if($this->ipsclass->DB->get_num_rows())
                    {
                            while($data = $this->ipsclass->DB->fetch_row())
                            {
                                    if ( preg_match( "/^image/i", $data['atype_mimetype'] )  )
                                    {
                                            $upload->allowed_file_ext[] = $data['atype_extension'];
                                    }
                            }
                    }

                    //-----------------------------------------
                    // Upload...
                    //-----------------------------------------

                    $upload->upload_process();

                    //-----------------------------------------
                    // Error?
                    //-----------------------------------------

                    if ( $upload->error_no )
                    {

                            switch( $upload->error_no )
                            {
                                    case 1:
                                           // No upload
                                           $error_msg = 'upload_failed';
                                           break;
                                    case 2:
                                           // Invalid file ext
                                           $error_msg = 'no_aw_type';
                                           break;
                                    case 3:
                                           // Too big...
                                           $error_msg = 'upload_to_big';
                                           break;
                                    case 4:
                                           // Cannot move uploaded file
                                           $error_msg = 'upload_failed';
                                           break;
                                    case 5:
                                           // Possible XSS attack (image isn't an image)
                                           $error_msg = 'upload_failed';
                                           break;
                            }

                            return $error_msg;

                    }

                    //-----------------------------------------
                    // Still here?
                    //-----------------------------------------

                    $img_attributes = @GetImageSize($upload->saved_upload_name);

                    $im['img']     = $upload->parsed_file_name;
                    $im['img_h']   = $img_attributes[1];
                    $im['img_w']   = $img_attributes[0];

                    //-----------------------------------------
                    // unlink old files
                    //-----------------------------------------

                    if( ($bash_img != $im['img']) and $bash_img )
                    {
                            $this->bash_uploaded_awards( $bash_img );
                    }

                    //-----------------------------------------
                    // Check image size...
                    //-----------------------------------------

                    $parse_on_standart_lib = false;

                    $this->ipsclass->input['images_transparent'] = intval($this->ipsclass->input['images_transparent']) ? 1 : 0;

                    $this->ipsclass->input['max_w'] = intval($this->ipsclass->input['max_w']);
                    $this->ipsclass->input['max_w']  = $this->ipsclass->input['max_w'] > 0 ? $this->ipsclass->input['max_w'] : 200;

                    $this->ipsclass->input['max_h'] = intval($this->ipsclass->input['max_h']);
                    $this->ipsclass->input['max_h'] = $this->ipsclass->input['max_h'] > 0 ? $this->ipsclass->input['max_h'] : 200;

                    if( ($img_attributes[2] == 1 or $img_attributes[2] == 3)
                         and !$image_save_transparent_lib->non_gd_201
                         and $this->ipsclass->input['images_transparent'])
                    {
                            $image_save_transparent_lib->newwidth  = $this->ipsclass->input['max_w'];
                            $image_save_transparent_lib->newheight = $this->ipsclass->input['max_h'];

                            $image_save_transparent_lib->dir_filename_in = ROOT_PATH.$this->ipsclass->vars['awrads_upload'];
                            $image_save_transparent_lib->filename_in     = $upload->parsed_file_name;
                            $image_save_transparent_lib->filename_out    = 'aw-'.$max_awards;

                            $return_max = $image_save_transparent_lib->resize_transparent();

                            if( $return_max === FALSE)
                            {
                                    $parse_on_standart_lib = true;
                            }
                            elseif( $return_max['thumb_location'] )
                            {
                                    $im['img']     = $return_max['thumb_location'];
                                    $im['img_w']   = $return_max['thumb_width'];
                                    $im['img_h']   = $return_max['thumb_height'];
                            }
                    }
                    else
                    {
                            $parse_on_standart_lib = true;
                    }

                    if( $parse_on_standart_lib )
                    {
                            $image->in_type        = 'file';
                            $image->out_type       = 'file';
                            $image->in_file_dir    = ROOT_PATH . $this->ipsclass->vars['awrads_upload'];
                            $image->in_file_name   = $upload->parsed_file_name;
                            $image->out_file_name  = 'aw-'.$max_awards;

                            $image->desired_width  = $this->ipsclass->input['max_w'];
                            $image->desired_height = $this->ipsclass->input['max_h'];

                            $return_max = $image->generate_thumbnail();

                            if($return_max['thumb_location'])
                            {
                                    $im['img']     = $return_max['thumb_location'];
                                    $im['img_w']   = $return_max['thumb_width'];
                                    $im['img_h']   = $return_max['thumb_height'];
                            }
                    }

                    //-----------------------------------------
                    // Check image size...
                    //-----------------------------------------

                    $this->ipsclass->input['mini_w'] = intval($this->ipsclass->input['mini_w']);
                    $this->ipsclass->input['mini_w']  = $this->ipsclass->input['mini_w'] > 0 ? $this->ipsclass->input['mini_w'] : 35;

                    $this->ipsclass->input['mini_h'] = intval($this->ipsclass->input['mini_h']);
                    $this->ipsclass->input['mini_h'] = $this->ipsclass->input['mini_h'] > 0 ? $this->ipsclass->input['mini_h'] : 35;


                    if( !$parse_on_standart_lib )
                    {

                            $image_save_transparent_lib->newwidth  = $this->ipsclass->input['mini_w'];
                            $image_save_transparent_lib->newheight = $this->ipsclass->input['mini_h'];

                            $image_save_transparent_lib->dir_filename_in = ROOT_PATH . $this->ipsclass->vars['awrads_upload'];
                            $image_save_transparent_lib->filename_in     = $upload->parsed_file_name;
                            $image_save_transparent_lib->filename_out    = 'aw-'.$max_awards.'_thumbnail';

                            $return_mini = $image_save_transparent_lib->resize_transparent();

                            if( $return_mini['thumb_location'] )
                            {
                                    $im['img_thumbnail'] = $return_mini['thumb_location'];
                                    $im['thumbnail_w']   = $return_mini['thumb_width'];
                                    $im['thumbnail_h']   = $return_mini['thumb_height'];
                            }
                    }
                    else
                    {
                            $image->in_type        = 'file';
                            $image->out_type       = 'file';
                            $image->in_file_dir    = ROOT_PATH . $this->ipsclass->vars['awrads_upload'];
                            $image->in_file_name   = $upload->parsed_file_name;
                            $image->out_file_name  = 'aw-'.$max_awards.'_thumbnail';

                            $image->desired_width  = $this->ipsclass->input['mini_w'];
                            $image->desired_height = $this->ipsclass->input['mini_h'];

                            $return_mini = $image->generate_thumbnail();

                            if($return_mini['thumb_location'])
                            {
                                    $im['img_thumbnail'] = $return_mini['thumb_location'];
                                    $im['thumbnail_w']   = $return_mini['thumb_width'];
                                    $im['thumbnail_h']   = $return_mini['thumb_height'];
                            }
                    }

                    //-----------------------------------------
                    // unlink old files
                    //-----------------------------------------

                    if( (trim($bash_img_thumbnail) != trim($im['img_thumbnail'])) and $bash_img_thumbnail)
                    {
                            $this->bash_uploaded_awards( trim($bash_img_thumbnail) );
                    }

                    //------------------------------
                    // remove big file
                    //------------------------------

                    if($upload->parsed_file_name != $im['img'])
                    {
                            $this->bash_uploaded_awards( $upload->parsed_file_name );
                    }

                    return $im;

            }
            else
            {
                    return 'upload_failed';
            }
    }

    /*-------------------------------------------------------------------------*/
    // Unlink needed files
    /*-------------------------------------------------------------------------*/

    function bash_uploaded_awards( $img = '')
    {
            $img = trim($img);

            if(!$img)
            {
                    return;
            }

            if ( @file_exists( ROOT_PATH.$this->ipsclass->vars['awrads_upload']."/".$img  ) )
            {
                    @unlink( ROOT_PATH.$this->ipsclass->vars['awrads_upload']."/".$img );
            }
    }

    /*-------------------------------------------------------------------------*/
    // Update Cache
    /*-------------------------------------------------------------------------*/

    function update_awards_cache()
    {
                $this->ipsclass->cache['awards_img_cache'] = array();

                $this->ipsclass->DB->simple_construct( array( 'select' => "*",
                                                              'from'   => 'awards_info',
                                                              'where'  => 'awards_status=1'
                                                         )      );

                $this->ipsclass->DB->simple_exec();

                while ( $i = $this->ipsclass->DB->fetch_row() )
                {
                        $this->ipsclass->cache['awards_img_cache'][ $i['id'] ] = $i;
                }

                $this->ipsclass->update_cache( array( 'name' => 'awards_img_cache', 'array' => 1, 'deletefirst' => 1 ) );
    }

    /*-------------------------------------------------------------------------*/
    // HTML: start form.
    /*-------------------------------------------------------------------------*/

    function html_start_form($additional_tags=array(), $js = '')
    {
                $form = "<form action='{$this->ipsclass->base_url}' method='POST' id='postingform'{$js} name='REPLIER'>".
                                "<input type='hidden' name='automodule' value='awards' />".
                                "<input type='hidden' name='s' value='".$this->ipsclass->session_id."' />".
                                "<input type='hidden' name='auth_key' value='".$this->ipsclass->return_md5_check()."' />";

                // Any other tags to add?

                if ( count( $additional_tags ) )
                {
                        foreach( $additional_tags as $k => $v )
                        {
                                $form .= "\n<input type='hidden' name='{$v[0]}' value='{$v[1]}'>";
                        }
                }

                return $form;
    }

    /*-------------------------------------------------------------------------*/
    // MODERATE ERROR:
    /*-------------------------------------------------------------------------*/

    function award_error($msg = 'moderate_no_permission')
    {
            $this->ipsclass->Error( array( 'LEVEL' => 2, 'MSG' => $msg ) );

            // Make sure we exit..
            exit();
    }

    /*-------------------------------------------------------------------------*/
    // INIT this lib in topics and ptofile
    /*-------------------------------------------------------------------------*/

    function personal_init()
    {
            //---------------------------------
            // init only in profile or topics
            //---------------------------------

            if($this->ipsclass->input['act'] != "st" and ($this->ipsclass->input['automodule'] != "awards" and $this->ipsclass->input['inc'] != 'comments') )
            {
                    //------------------------------------
                    // non parse awards flag
                    //------------------------------------

                    $this->non_init_lib = 1;
                    return;
            }

            //----------------------------------------------------
            // Component enable? .
            //----------------------------------------------------
            $has_com = 0;

            foreach( $this->ipsclass->cache['components'] as $com_id => $com_data)
            {
                    if( $com_data['com_section'] == 'awards' )
                    {
                            $has_com = 1;
                            break;
                    }
            }

            if(!$has_com)
            {
                    $this->non_init_lib = 1;
                    return;
            }

            $this->ipsclass->load_template( 'skin_awards_personal' );
            $this->ipsclass->load_language('lang_awards');

            if(!is_array($this->ipsclass->cache['awards_img_cache']))
            {
                    $this->update_awards_cache();
            }

            if( !strstr( ','.$this->ipsclass->vars['awards_perm'].',', ','.$this->ipsclass->member['mgroup'].',' ) )
            {
                    $this->can_accsess = 1;
            }

            $this->ipsclass->vars['awards_line_count'] = intval($this->ipsclass->vars['awards_line_count']) > 0 ? intval($this->ipsclass->vars['awards_line_count']) : 3;
    }

    /*-------------------------------------------------------------------------*/
    // Render digital member awards
    /*-------------------------------------------------------------------------*/

    function render_member_digital($mid = 0, $count = "" )
    {
            $no_awards = 0;

            //------------------------------------
            // System offline?
            //------------------------------------

            if( !$this->ipsclass->vars['awards_onoff'])
            {
                    return;
            }

            //------------------------------------
            // Only image type?
            //------------------------------------
            if( $this->ipsclass->vars['awrads_type'] == 1 )
            {
                    return;
            }

            //------------------------------------
            // Have member?
            //------------------------------------

            if( !$mid )
            {
                    return;
            }


            $images = unserialize(stripslashes($count));
            $count  = 0;

            if( is_array($images) )
            {
                    foreach($images as $id => $data)
                    {
                            $awards = $this->ipsclass->cache['awards_img_cache'][ $data[1] ];

                            if(!$awards['id'])
                            {
                                    continue;
                            }

                            $count ++;
                    }
            }

            if(!$count and !$this->ipsclass->vars['awards_no_show'])
            {
                    return;
            }
            elseif(!$count)
            {
                    $count = $this->ipsclass->lang['awards_no_member'];

                    $no_awards = 1;
            }

            if( !$this->can_accsess )
            {
                    return $this->ipsclass->compiled_templates['skin_awards_personal']->awards_digital( $count );
            }
            else
            {
                    if( ! $this->ipsclass->can_use_fancy_js and !$no_awards)
                    {
                            $count_link = $this->ipsclass->compiled_templates['skin_awards_personal']->js_link( $mid, $count );
                    }
                    elseif(!$no_awards)
                    {
                            $count_link = $this->ipsclass->compiled_templates['skin_awards_personal']->xml_link( $mid, $count );
                    }
                    else
                    {
                            return $this->ipsclass->compiled_templates['skin_awards_personal']->awards_digital( $count );
                    }

                    //------------------------------
                    // in topic we are need: CONTENT <br />
                    //------------------------------

                    return $this->ipsclass->compiled_templates['skin_awards_personal']->awards_digital( $count_link );

            }

    }


    /*-------------------------------------------------------------------------*/
    // Render images member awards
    /*-------------------------------------------------------------------------*/

    function render_member_image($mid = 0, $images = '')
    {
            $no_awards = 0;

            //------------------------------------
            // System offline?
            //------------------------------------

            if( !$this->ipsclass->vars['awards_onoff'] )
            {
                    return;
            }

            //------------------------------------
            // Only digital type?
            //------------------------------------
            if($this->ipsclass->vars['awrads_type'] == 0)
            {
                    return;
            }

            //------------------------------------
            // Have member?
            //------------------------------------

            if( !$mid )
            {
                    return;
            }

            //------------------------------------
            // Have awards?
            //------------------------------------

            if($images == '')
            {
                    return;
            }

            $images = unserialize(stripslashes($images));

            if( ! count($images) )
            {
                    return;
            }

            $content = '';
            $count_in_row = 1;

            foreach($images as $id => $data)
            {
                    $awards = $this->ipsclass->cache['awards_img_cache'][ $data[1] ];

                    if(!$awards['id'])
                    {
                            continue;
                    }

                    if($awards['img_thumbnail'])
                    {
                            $awards['img']   = $awards['img_thumbnail'];
                            $awards['img_h'] = $awards['thumbnail_h'];
                            $awards['img_w'] = $awards['thumbnail_w'];
                    }

                    $content .= $this->ipsclass->compiled_templates['skin_awards_personal']->awards_image( $awards );

                    if(($count_in_row % $this->ipsclass->vars['awards_line_count']) == 0)
                    {
                            $content .= $this->ipsclass->compiled_templates['skin_awards_personal']->break_line( );
                    }

                    if($this->ipsclass->vars['awards_count'] and $this->ipsclass->vars['awards_count'] == $count_in_row)
                    {
                            $content .= $this->ipsclass->compiled_templates['skin_awards_personal']->break_line( );
                            break;
                    }

                    $count_in_row ++;
            }

            if((($count_in_row-1) % $this->ipsclass->vars['awards_line_count']) != 0)
            {
                    if($this->ipsclass->vars['awards_count'] != $count_in_row)
                    {
                            $content .= $this->ipsclass->compiled_templates['skin_awards_personal']->break_line( );
                    }
            }


            if( !$this->can_accsess )
            {
                    return $content;
            }
            else
            {

                    if( ! $this->ipsclass->can_use_fancy_js )
                    {
                            $content = $this->ipsclass->compiled_templates['skin_awards_personal']->js_link( $mid, $content );
                    }
                    else
                    {
                            $content = $this->ipsclass->compiled_templates['skin_awards_personal']->xml_link( $mid, $content );
                    }

                    return $content;
            }


    }


    /*-------------------------------------------------------------------------*/
    // Get comments permission
    /*-------------------------------------------------------------------------*/

    function get_comments_permission( $member, $own_show_awards = 0 )
    {

        //------------------------------------
        // Enable or desable comments?
        //------------------------------------
    	if( !$this->ipsclass->vars['awards_comments'] )
    	{
    		$this->comments_enable = 0;
    		return;
    	}


    	if( !$this->ipsclass->cache['group_cache'][ $member['mgroup'] ]['g_awards_has_comments'] )
    	{
    		$this->comments_enable = 0;
    		return;
    	}

        //------------------------------------
        // Member choce?
        //------------------------------------
    	if( $this->ipsclass->vars['awards_comments_need_own'] )
    	{
    		if( !$member['awards_comments'] )
    		{
    			$this->comments_enable = 0;
    			return;
    		}
    	}

		if( !$this->ipsclass->member['g_awards_add_comments'] )
		{
			$this->comments_add = 0;
		}

		if( $this->ipsclass->member['g_awards_mod_comments'] )
		{
			$this->comments_mod = 1;
		}

		if( $this->ipsclass->member['g_is_supmod'] )
		{
			$this->comments_mod = 1;
		}

		if( $this->ipsclass->member['g_awards_mod_own_comments'] and $own_show_awards)
		{
			$this->comments_mod = 1;
		}

    }

    /*-------------------------------------------------------------------------*/
    // Init Awards system
    /*-------------------------------------------------------------------------*/

    function init_module()
    {
    	// To-do list              req                                    file                         class
        $this->inclist = array (   'idx'          =>        array(        'statistics',                'awards_statistics'),
        						   'ucp_main'     =>        array(        'ucp',                       'ucp' ),
                                   'awardscp'     =>        array(        'awardscp',                  'awardscp' ),
                                   'memawards'    =>        array(        'awards_xml',                'awards_xml' ),
                                   'comments'     =>        array(        'comments',                  'awards_comments' ),
                                   'findcomment'  =>        array(        'findcomment',               'findcomment' ),
                                   'report'       => 		array(        'reports',				   'reports'),
                                   );
    }

}
?>