<?php
/*
+--------------------------------------------------------------------------
|   Awards System Module v3.1.0
|   ========================================
|   by SAT
|   (c) 2005 - 2008 Game-Play.ru TEAM
|   http://www.game-play.ru
|   ========================================
|   Email: sat@game-play.ru
+---------------------------------------------------------------------------
*/

/**
* Library/Awards System Resize GIF and PNG
*
*
* @package          Awards System
* @subpackage       Library
* @author           SAT
* @since            3.0.1
* @version          1.0.1
*/

class image__transparent_lib
{

    var $ipsclass;


    var $filename_in  = '';
    var $filename_out = '';
    var $dir_filename_in  = '';
    var $dir_filename_out = '';
    var $in_file_complete = '';

    var $newwidth     = 0;
    var $newheight    = 0;

    var $non_gd_201    = false;
    var $im_inc        = false;
    var $img_library   = 'gd';

    var $non_parse_gif = true;
    var $non_parse_png = true;

    var $ips_image_lib = '';


    /*-------------------------------------------------------------------------*/
    // Constructor....
    /*-------------------------------------------------------------------------*/

    function image_lib( )
    {

    }

    /*-------------------------------------------------------------------------*/
    // INIT
    /*-------------------------------------------------------------------------*/

    function init_lib(  )
    {
            //--------------------------------------------
            // see in settings, what chose GD version
            //--------------------------------------------

            $this->img_library = $this->ipsclass->vars['awards_img_suite'];

            //if( $this->ipsclass->vars['gd_version'] < 2)
            if( $this->ipsclass->vars['awards_img_suite'] != "im" )
            {
                    $this->non_gd_201 = true;
                    $this->im_inc     = true;
                    return;
            }

            if( $this->ipsclass->vars['awards_img_suite'] != "gd" )
            {
                    $this->non_gd_201 = true;
                    return;
            }


            //--------------------------------------------
            // we are need GD version 2.0.1 or hight
            //--------------------------------------------

            $gdvars = @gd_info();

            if( $gdvars )
            {
                    $gdvars["GD Version"] = preg_replace("#(^|.+?\()([0-9\.]+).+#is", "\\2", $gdvars["GD Version"]);

                    if( $gdvars["GD Version"] < '2.0.1')
                    {
                            $this->non_gd_201 = true;
                    }
            }
            else
            {
                    $this->non_gd_201 = true;
            }

            //----------------------------------
            // Extansion can parse
            //----------------------------------

            if( !$this->non_gd_201 )
            {
                    if( @function_exists('imageCreateFromGif') and @function_exists('imageGIF'))
                    {
                            $this->non_parse_gif = false;
                    }

                    if( @function_exists('imageCreateFromPng') and @function_exists('imagePNG'))
                    {
                            $this->non_parse_png = false;
                    }
            }

    }

    /*-------------------------------------------------------------------------*/
    // Clean paths
    /*-------------------------------------------------------------------------*/

    function clean_paths()
    {
            $this->dir_filename_in   = preg_replace( "#(^/|/$)#", "", $this->dir_filename_in );
            $this->dir_filename_out  = preg_replace( "#(^/|/$)#", "", $this->dir_filename_out );

            if ( $this->dir_filename_in and $this->filename_in )
            {
                    $this->in_file_complete = $this->dir_filename_in.'/'.$this->filename_in;
            }
            else
            {
                    $this->in_file_complete = $this->filename_in;
            }

            if ( ! $this->dir_filename_out )
            {
                    $this->dir_filename_out = $this->dir_filename_in;
            }
    }

    /*-------------------------------------------------------------------------*/
    // RESIZE with save transparent
    /*-------------------------------------------------------------------------*/

    function resize_transparent( )
    {
            if( $this->img_library == 'im' )
            {
                    $return = $this->thumbnail_im();
            }
            else
            {
                    $return = $this->thumbnail_gd();
            }


            return $return;
    }

    /*-------------------------------------------------------------------------*/
    // RESIZE with Image Magic
    /*-------------------------------------------------------------------------*/

    function thumbnail_im( )
    {
            $this->clean_paths();


            $im = $this->ips_image_lib->scale_image( array( 'max_width'  => $this->newwidth,
                                                            'max_height' => $this->newheight,
                                                            'cur_width'  => $width,
                                                            'cur_height' => $height
                                                                    )      );

            $return['thumb_width']   = $im['img_width'];
            $return['thumb_height']  = $im['img_height'];

            // get IM path
            $im = $this->ipsclass->vars['awards_im_path'];

            // resize
            @system( "{$im}convert -geometry {$im['img_width']}x{$im['img_height']} {$this->in_file_complete} {$this->dir_filename_out}/{$this->filename_out}.temp" );

            // Was the thumbnail created successfully?
            if( file_exists( "{$this->dir_filename_out}/{$this->filename_out}.temp" ) )
            {
                    @rename( "{$this->dir_filename_out}/{$this->filename_out}.temp", $this->dir_filename_out.'/'.$this->filename_out );
                    @chmod( $this->dir_filename_out.'/'.$this->filename_out, 0777 );

                    $return['thumb_location'] = $this->filename_out;

                    return $return;
            }
            else
            {
                    return FALSE;
            }
    }

    /*-------------------------------------------------------------------------*/
    // RESIZE with GD2
    /*-------------------------------------------------------------------------*/

    function thumbnail_gd( )
    {
            //------------------------
            // INIT
            //------------------------

            $src       = '';
            $height    = 0;
            $width     = 0;
            $parse_ext = array( 1 => 'gif', 3 => 'png'  );
            $type_ext  = 0;
            $type      = '';

            $this->clean_paths();

            //------------------------
            // GD version < 2.0.1?
            //------------------------

            if( $this->non_gd_201 )
            {
                    return FALSE;
            }

            //------------------------

            $this->newwidth = intval( $this->newwidth ) > 0 ? intval( $this->newwidth ) : 0;
            $this->newheight = intval( $this->newheight ) > 0 ? intval( $this->newheight ) : 0;

            if( !$this->newheight or !$this->newwidth)
            {
                    return FALSE;
            }

            list( $width, $height, $type_ext ) = @GetImageSize( $this->in_file_complete );

            $width  = intval( $width )  > 0 ? intval( $width )  : 0;
            $height = intval( $height ) > 0 ? intval( $height ) : 0;

            if( !$width or !$height )
            {
                    return FALSE;
            }


            //------------------------
            // can parse image?
            //------------------------

            $type = $parse_ext[ $type_ext ];

            if( !$type  )
            {
                    return FALSE;
            }
            elseif( $type == 'gif' and $this->non_parse_gif)
            {
                    return FALSE;
            }
            elseif( $type == 'gif' and  $this->non_parse_png )
            {
                    return FALSE;
            }


            if ( ( $width > $this->newwidth ) OR ( $height > $this->newheight ) )
            {
                    $im = $this->ips_image_lib->scale_image( array( 'max_width'  => $this->newwidth,
                                                                    'max_height' => $this->newheight,
                                                                    'cur_width'  => $width,
                                                                    'cur_height' => $height
                                                                    )      );

                    $return['thumb_width']   = $im['img_width'];
                    $return['thumb_height']  = $im['img_height'];


                    //--------------------------
                    // Allowed types: image/gif, image/x-png
                    //--------------------------

                    switch($type)
                    {
                            case 'gif':
                                   $image = @imageCreateFromGif( $this->in_file_complete );
                                    break;
                            case 'png':
                                   $image = @imageCreateFromPng( $this->in_file_complete );
                                    break;
                            default:
                                    break;
                    }

                    //--------------------------
                    // Create image?
                    //--------------------------

                    if( !$image )
                    {
                            $this->non_gd_201 = true;
                            return FALSE;
                    }

                    //--------------------------
                    // Save png transparent
                    //-------------------------

                    if( $type == 'png' )
                    {
                            $dest = @imagecreatetruecolor( $im['img_width'], $im['img_height'] );

                            @imagealphablending( $dest, FALSE );
                            @imagesavealpha( $dest, TRUE );

                            $transparent = @imagecolorallocatealpha($dest, 255, 255, 255, 127);
                            @imagefilledrectangle($dest, 0, 0, $im['img_width'], $im['img_height'], $transparent);

                            @imagecopyresampled($dest, $image, 0, 0, 0, 0, $im['img_width'], $im['img_height'], $width, $height );
                    }
                    //--------------------------
                    // Save gif transparent
                    //-------------------------
                    else
                    {
                            $tpcolor = @imageColorat($image, 0, 0);

                            // in the real world, you'd better test all four corners, not just one!
                            $dest = @imageCreate($im['img_width'], $im['img_height']);

                            // $dest automatically has a black fill...
                            @imagePaletteCopy($dest, $image);
                            @imageCopyResampled($dest, $image, 0, 0, 0, 0, $im['img_width'], $im['img_height'], $width, $height);
                            $pixel_over_black = @imageColorat($image, 0, 0);

                            // ...but now make the fill white...
                            $bg = @imageColoralLocate($dest, 255, 255, 255);
                            @imageFilledRectangle($dest, 0, 0, $im['img_width'], $im['img_height'], $bg);
                            @imageCopyResampled($dest, $image, 0, 0, 0, 0, $im['img_width'], $im['img_height'], $width, $height);
                            $pixel_over_white = @imageColorat($dest, 0, 0);

                            // ...to test if transparency causes the fill color to show through:
                            if($pixel_over_black != $pixel_over_white)
                            {
                                    // Background IS transparent
                                    @imageFilledRectangle($dest, 0, 0, $im['img_width'], $im['img_height'], $tpcolor);
                                    @imageCopyResampled($dest, $image, 0, 0, 0, 0, $im['img_width'], $im['img_height'], $width, $height);
                                    @imageColorTransparent($dest, $tpcolor);
                            }
                    }



                    //----------------------------------
                    // output image
                    //----------------------------------

                    switch( $type ) // Allowed types: image/gif,image/x-png
                    {
                            case 'gif':
                                   $this->filename_out .= '.gif';
                                   @imageGIF($dest, $this->dir_filename_out.'/'.$this->filename_out);
                                   break;
                            case 'png':
                                   $this->filename_out .= '.png';
                                   @imagePNG($dest, $this->dir_filename_out.'/'.$this->filename_out);
                                   break;
                    }

                    @chmod( $this->dir_filename_out.'/'.$this->filename_out, 0777 );

                    @imageDestroy( $image );
                    @imageDestroy( $dest );

                    $return['thumb_location'] = $this->filename_out;

                    return $return;
            }

    }


}
?>