<?php

/*
+--------------------------------------------------------------------------
|   Awards System Module v3.1.0
|   ========================================
|   by SAT
|   (c) 2005 - 2008 Game-Play.ru TEAM
|   http://www.game-play.ru
|   ========================================
|   Email: sat@game-play.ru
+---------------------------------------------------------------------------
|
|   > API: Get Member Awards
|   > Module written by SAT
|   > Date started: Sunday 27/04/2008
|
+--------------------------------------------------------------------------
*/


/**
* API: Awards System
*
* EXAMPLE USAGE
* <code>
* To follow
* </code>
*
* @package		InvisionPowerBoard
* @subpackage	APIs
* @author		Brandon Farber
* @copyright	Invision Power Services, Inc.
* @version		2.1
*/

if ( ! defined( 'IPS_API_PATH' ) )
{
	/**
	* Define classes path
	*/
	define( 'IPS_API_PATH', dirname(__FILE__) ? dirname(__FILE__) : '.' );
}

if ( ! class_exists( 'api_core' ) )
{
	require_once( IPS_API_PATH.'/api_core.php' );
}

/**
* API: Gallery
*
* This class will pull the last 5 images a user has submitted to Gallery.
*
* @package		InvisionPowerBoard
* @subpackage	APIs
* @author  	 	Brandon Farber
* @version		2.1
* @since		2.2.0
*/
class api_awards extends api_core
{
	/**
	* IPS Class Object
	*
	* @var object
	*/
	//var $ipsclass;

	var $awards_lib;


	/*-------------------------------------------------------------------------*/
	// Returns an array of awards data
	/*-------------------------------------------------------------------------*/
	/**
	* Returns an array of awards data
	*
	* @return   array	Array of awards data
	*/
	function return_awards_data( $member_id = 0, $limit = 0 )
	{
		if( !$member_id )
		{
			return array();
		}

		//-----------------------------------------
		// Permissions?
		//-----------------------------------------

		if( strstr( ','.$this->ipsclass->vars['awards_perm'].',', ','.$this->ipsclass->member['mgroup'].',' ) )
		{
			return array();
		}

		//-----------------------------------------
		// INIT
		//-----------------------------------------

		$awards    = array();

		$member_id = intval( $member_id );

		$query_array = array( 'select'	=> 'a.*',
												 'from'		=> array( 'awards' => 'a' ),
												 'where'	=> "a.mid={$member_id} AND ai.awards_status=1",
												 'add_join'	=> array(
												 				1 => array( 'type'		=> 'left',
												 							'select'	=> 'ai.*',
												 							'from'		=> array( 'awards_info' => 'ai' ),
												 							'where'		=> 'ai.id=a.awards_id',
												 						  ),
												 				2 => array( 'type'		=> 'left',
												 							'select'	=> 'm.members_display_name',
												 							'from'		=> array( 'members' => 'm' ),
												 							'where'		=> "m.id=a.cid",
												 						  ),
												 					),
												 'order'	=> 'a.aid DESC',
										);


		//----------------------------
		// need limit resault array?
		//----------------------------

		if( $limit != 0 )
		{
			$query_array['limit'] = array( 0, $limit );
		}

		$this->ipsclass->DB->build_query( 	$query_array	);

		$this->res = $this->ipsclass->DB->exec_query();

		$this->total = $this->ipsclass->DB->get_num_rows( $this->res );


		while( $rows = $this->ipsclass->DB->fetch_row() )
		{
				$awards[ $rows['aid'] ] = $rows;
		}

		return $awards;


	}

}



?>