<?php
/*
+--------------------------------------------------------------------------
|   Awards System Module v3.1.0
|   ========================================
|   by SAT
|   (c) 2005 - 2008 Game-Play.ru TEAM
|   http://www.game-play.ru
|   ========================================
|   Email: sat@game-play.ru
+---------------------------------------------------------------------------
*/

class awards_sql_queries extends db_driver_mysql
{

     var $db  = "";
     var $tbl = "";

    /*========================================================================*/
    // Set up...
    /*========================================================================*/

    function sql_queries( $obj )
    {
            $this->db = $obj;

            if ( ! $this->db->obj['sql_tbl_prefix'] )
            {
                    $this->db->obj['sql_tbl_prefix'] = '".SQL_PREFIX."';
            }

            $this->tbl = $this->db->obj['sql_tbl_prefix'];
    }

    /*========================================================================*/


    function get_member_award( $a )
    {
                return "SELECT a.*, ai.*
                                FROM ".SQL_PREFIX."awards a
                                 LEFT JOIN  ".SQL_PREFIX."awards_info ai ON (ai.id=a.awards_id)
                                WHERE a.mid={$a['mid']}
                                ORDER BY aid DESC";
    }

    function get_member_notice( $a )
    {
                return "SELECT m.id, m.members_display_name, me.vdirs
                                FROM ".SQL_PREFIX."members m
                                 LEFT JOIN  ".SQL_PREFIX."member_extra me ON(me.id = m.id)
                                WHERE m.id={$a['mid']}";
    }

    function get_member_award_to_edit( $a )
    {
            return "SELECT m.members_display_name, m.id, m.awards_cache, ai.title, a.reason, a.awards_id, a.mname, a.aid
                                FROM ".SQL_PREFIX."awards a
                                 LEFT JOIN ".SQL_PREFIX."awards_info ai ON (ai.id=a.awards_id)
                                 LEFT JOIN ".SQL_PREFIX."members m ON (m.id=a.mid)
                                WHERE a.aid={$a['aid']} and ai.awards_status=1";
    }

    function get_member_award_to_edit_do( $a )
    {
            return "SELECT m.members_display_name, m.id, m.awards_cache, a.aid
                                FROM ".SQL_PREFIX."awards a
                                 LEFT JOIN ".SQL_PREFIX."members m ON (m.id=a.mid)
                                WHERE a.aid={$a['aid']}";
    }

    function delet_member_award_do( $a )
    {
            return "SELECT m.id, m.members_display_name, m.awards_cache, m.awards_dig, m.members_cache, a.aid
                                FROM ".SQL_PREFIX."awards a
                                 LEFT JOIN ".SQL_PREFIX."members m ON (m.id=a.mid)
                                WHERE a.aid='{$a['aid']}'";
    }


    function get_member_award_personal( $a )
    {
            return "SELECT a.*, ai.*, m.members_display_name
                                FROM ".SQL_PREFIX."awards a
                                 LEFT JOIN ".SQL_PREFIX."awards_info ai ON (ai.id=a.awards_id )
                                 LEFT JOIN ".SQL_PREFIX."members m ON (m.id=a.cid)
                                WHERE a.mid={$a['mid']} AND ai.awards_status=1";
    }


    function get_awards_list( $a )
    {
            return "SELECT a.awards_id, a.mid, m.mgroup, m.members_display_name
                                FROM ".SQL_PREFIX."awards a
                                 LEFT JOIN ".SQL_PREFIX."members m ON (m.id=a.mid)
                                WHERE a.awards_id IN (".implode(',', $a['ids']).") ";
    }

    function get_awards_stats( $a )
    {
            return "SELECT ai.id
                                FROM ".SQL_PREFIX."awards a
                                 LEFT JOIN ".SQL_PREFIX."awards_info ai ON (a.awards_id=ai.id)
                                WHERE ai.awards_status=1
                                 GROUP BY a.awards_id
                                 ORDER BY ai.title {$a['sort_order']}
                                LIMIT {$a['limit_a']}, {$a['limit_b']}";
    }

    function get_awards_stats_count( $a )
    {
            return "SELECT ai.id
                                FROM ".SQL_PREFIX."awards a
                                 LEFT JOIN ".SQL_PREFIX."awards_info ai ON (a.awards_id=ai.id)
                                WHERE ai.awards_status=1
                                 GROUP BY a.awards_id";
    }

    function get_mem_stats_count( $a )
    {
            return "SELECT a.aid
                                FROM ".SQL_PREFIX."awards a
                                 LEFT JOIN ".SQL_PREFIX."awards_info ai ON (a.awards_id=ai.id)
                                WHERE ai.awards_status=1
                                 GROUP BY a.mid";
    }

    function get_mem_stats( $a )
    {
            return "SELECT m.id as member_id, m.awards_cache, m.members_display_name, m.mgroup, m.awards_comments,
                           COUNT(a.aid) as count
                                FROM ".SQL_PREFIX."awards a
                                 LEFT JOIN ".SQL_PREFIX."awards_info ai ON (a.awards_id=ai.id)
                                 LEFT JOIN ".SQL_PREFIX."members m ON (a.mid=m.id)
                                WHERE ai.awards_status=1
                                GROUP BY a.mid
                                ORDER BY {$a['s_key']} {$a['s_order']}
                                LIMIT {$a['limit_a']},{$a['limit_b']}";
    }


    function get_award_comments_info( $a )
    {
            return "SELECT m.id as member_id, m.awards_cache, m.members_display_name, m.mgroup, m.awards_comments, m.awards_dig,
                           a.*, ai.*,
                           ma.members_display_name as mem_disp_name, m.mgroup as mgr
                                FROM ".SQL_PREFIX."awards a
                                 LEFT JOIN ".SQL_PREFIX."awards_info ai ON (a.awards_id=ai.id)
                                 LEFT JOIN ".SQL_PREFIX."members m ON (a.cid=m.id)
                                 LEFT JOIN ".SQL_PREFIX."members ma ON (a.mid=ma.id)
                                WHERE a.aid={$a['aid']} AND ai.awards_status=1";
    }


    function get_award_comments_xml( $a )
    {
            return "SELECT m.id as member_id, m.awards_cache, m.members_display_name, m.mgroup, m.awards_comments, m.awards_dig,
                           a.*, ai.*,c.*
                                FROM ".SQL_PREFIX."awards_comments c
                                 LEFT JOIN ".SQL_PREFIX."awards a ON(c.award_id=a.aid)
                                 LEFT JOIN ".SQL_PREFIX."awards_info ai ON (a.awards_id=ai.id)
                                 LEFT JOIN ".SQL_PREFIX."members m ON (a.mid=m.id)
                                WHERE c.pid={$a['com']} AND ai.awards_status=1";
    }


	function comments_get_quoted( $a )
	{
		return "SELECT c.*
					FROM ".SQL_PREFIX."awards_comments c
					WHERE c.pid IN (".implode(",", $a['quoted_pids']).")";
	}

    function awards_contact_member_report_get_own_awards_mod( $a )
    {
            return "SELECT m.id, m.members_display_name as name, m.email, m.language, m.members_disable_pm
                             FROM ".SQL_PREFIX."groups g
                               LEFT JOIN ".SQL_PREFIX."members m ON(m.mgroup=g.g_id)
                             WHERE g.g_awards_mod_own_comments=1 AND m.id={$a['mid']}";
    }

    function awards_contact_member_report_get_awards_mod( $a )
    {
            return "SELECT m.id, m.members_display_name as name, m.email, m.language, m.members_disable_pm
                             FROM ".SQL_PREFIX."groups g
                               LEFT JOIN ".SQL_PREFIX."members m ON(m.mgroup=g.g_id)
                             WHERE g.g_awards_mod_comments=1";
    }

    function awards_contact_member_report_get_cpaccess( $a )
    {
            return "SELECT m.id, m.members_display_name as name, m.email, m.language, m.members_disable_pm
                             FROM ".SQL_PREFIX."groups g
                               LEFT JOIN ".SQL_PREFIX."members m ON(m.mgroup=g.g_id)
                             WHERE g.g_access_cp=1";
    }

    function awards_contact_member_report_get_supmod( $a )
    {
            return "SELECT m.id, m.members_display_name as name, m.email, m.language, m.members_disable_pm
                             FROM ".SQL_PREFIX."groups g
                               LEFT JOIN ".SQL_PREFIX."members m ON(m.mgroup=g.g_id)
                             WHERE g.g_is_supmod=1";
    }

} // end class


?>