<?php
/*
+--------------------------------------------------------------------------
|   Awards System Module v3.1.0
|   ========================================
|   by SAT
|   (c) 2005 - 2008 Game-Play.ru TEAM
|   http://www.game-play.ru
|   ========================================
|   Email: sat@game-play.ru
+---------------------------------------------------------------------------
*/

if ( ! defined( 'IN_IPB' ) )
{
        print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded 'admin.php'.";
        exit();
}

/*
+--------------------------------------------------------------------------
|   This module has two functions:
|   get_session_variables: Return the session variables for the class_session functions
|   parse_online_entries: Parses an array from online.php
|   See each function for more information
+--------------------------------------------------------------------------
*/

//-----------------------------------------
// This must always be 'components_location'
//-----------------------------------------

class components_location_awards
{
        var $ipsclass;

        //                            INC list               location_type
        var        $inc_q = array (    'idx'             =>  'list',
                                       'ucp_main'        =>  'ucp',
                                       'awardscp'        =>  'ucp',
                                       'comments'        =>  'comments',
                                  );

        /*-------------------------------------------------------------------------*/
        // get_session_variables
        // Returns:
        // array( '1_type' => {location type #1} [ char(10) ]
        //        '1_id'   => {location ID #1}   [ int(10)  ]
        //        '2_type' => {location type #2} [ char(10) ]
        //        '2_id'   => {location ID #2}   [ int(10)  ]
        //        '3_type' => {location type #3} [ char(10) ]
        //        '3_id'   => {location ID #3}   [ int(10)  ]
        //      );
        // All are optional.
        // Use this to populate the 'module_id_*' fields in the session table
        // so you can check in your own scripts it the member is active in your module
        // {variable} can be 30 chrs long and alpha numerical
        // "location" in the sessions table will be the name of the module called
        /*-------------------------------------------------------------------------*/

        function get_session_variables()
        {
                $return_array = array();

                if ( !isset($this->ipsclass->input['inc']) )
                {
                        $this->ipsclass->input['inc'] = 'idx';
                }
                $inc = ( isset( $this->inc_q[ $this->ipsclass->input['inc'] ] ) ? strtolower($this->ipsclass->input['inc']) : 'idx' );

                $return_array['1_type'] = $this->inc_q[ $inc ];

                if($this->inc_q[ $inc ] == 'list')
                {
                        $return_array['2_type'] = $this->ipsclass->input['CODE'];
                }

                if($this->inc_q[ $inc ] == 'comments')
                {
                        $return_array['1_id'] = intval($this->ipsclass->input['aid']);
                }

                return $return_array;
        }

        /*-------------------------------------------------------------------------*/
        // parse_online_entries
        // INPUT: $array IS:
        // $array[ $session_id ] = $session_array;
        // Session array is DB row from ibf_sessions
        // EXPECTED RETURN ------------------------------------
        // $array[ $session_id ]['_parsed'] = 1;
        // $array[ $session_id ]['_url']    = {Location url}
        // $array[ $session_id ]['_text']   = {Location text}
        // $array[ $session_id ] = $session_array...
        //
        // YOU ARE RESPONSIBLE FOR PERMISSION CHECKS. IF THE MEMBER DOESN'T
        // HAVE PERMISSION RETURN '_url'    => $this->ipsclass->base_url,
        //                                                   '_text'   => $this->ipsclass->lang['board_index'],
        //                                                  '_parsed' => 1 { as well as the rest of $session_array }
        /*-------------------------------------------------------------------------*/

        function parse_online_entries( $array=array() )
        {
                //-----------------------------------------
                // INIT
                //-----------------------------------------

                $return = array();

                //---------------------------
                // awards system offline?
                //---------------------------

                $parse_localion = 1;

                if( !$this->ipsclass->vars['awards_onoff'] && !$this->ipsclass->member['g_access_offline'] )
                {
                        $parse_localion = 0;
                }

                //-----------------------------------------
                // Load language file
                //-----------------------------------------

                if ( ! isset( $this->ipsclass->lang['awards_loc_all_stat'] ) )
                {
                        $this->ipsclass->load_language( 'lang_awards_location' );
                }

                //-----------------------------------------
                // LOOP
                //-----------------------------------------

                foreach( $array as $session_id => $session_array )
                {
                        //-----------------------------------------
                        // heh... locatiol should has url :(
                        //-----------------------------------------

                        $location = "{$this->ipsclass->base_url}automodule=awards";

                        //-----------------------------------------
                        // member parsed online ststistics always,
                        // except for if member location in UCP
                        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        // ($parsed = 1) => Show Awards System location
                        // ($parsed = 0) => Show forum location
                        //-----------------------------------------

                        $parsed   = 1;

                        if ( $session_array['location'] == 'mod:awards' && $parse_localion)
                        {

                                //---------------------------
                                //  Viewing member's statistic?
                                //---------------------------

                                if ( $session_array['location_1_type'] == 'memstat' )
                                {
                                        $text = $this->ipsclass->lang['awards_loc_mem_stat'];
                                }

                                elseif( $session_array['location_1_type'] == 'list' and $session_array['location_2_type'] == 'personal')
                                {
                                        $text = $this->ipsclass->lang['awards_loc_mem_stat'];
                                }

                                //---------------------------
                                //  Viewing USER CONTROL PANEL?
                                //---------------------------

                                elseif ( $session_array['location_1_type'] == 'ucp' )
                                {
                                        $parsed   = 0; // not parse ucp location
                                        $session_array['location'] = 'UserCP,,';
                                }

                                //---------------------------
                                //  Viewing award comments?
                                //---------------------------

                                elseif ( $session_array['location_1_type'] == 'comments' and $session_array['location_1_id'] )
                                {
                                        $text = $this->ipsclass->lang['awards_loc_mem_comm'];
                                        $location = "{$this->ipsclass->base_url}automodule=awards&inc=comments&aid=".intval($session_array['location_1_id']);
                                }

                                //---------------------------
                                //  Viewing forum awards statistics?
                                //---------------------------

                                else
                                {
                                        $text = $this->ipsclass->lang['awards_loc_all_stat'];
                                }

                        }

                        $return[ $session_id ] = array_merge( $session_array, array( '_url' => $location, '_text' => $text, '_parsed' => $parsed) );
                }

                return $return;
        }

}
?>